import java.awt.*;
import java.applet.*;
import java.io.*;
import java.lang.Math;

class PoleCanvas extends java.awt.Canvas
{
   private int xdim=400,ydim=200;	//Width and height of canvas in pixels
   private int x0 = xdim / 2;
   private int y0 = ydim - 20 + 39;
   private int h = (ydim * 5 / 6);
   private int w = h / 25;
   private int[] xrect = new int[4];
   private int[] yrect = new int[4];
//   private Image offscreen;	
   
//Constructor: Sets background color, sizes Canvas, initializes canvas grid                    */
   public PoleCanvas()
   {  setBackground(Color.black);
	  this.setSize(xdim,ydim+126+39);
      //reset();
	  
	  Position p = new Position();
	  p.theta = 0.0;
	  getRect(p);
   }
   
   public void getRect(Position p)
	   /* Sets the bounds of the rectangle */
   {
	   double theta = p.theta;
	   
	   double convert = xdim / 2; /* Conversion along x - axis */
	   x0 = (int)(xdim / 2);
	   x0 = (int)(x0 + p.xbase * convert);
	   
	   // Point A
	   xrect[0] = (int)(x0 - (w/2)*Math.cos(theta));
	   yrect[0] = (int)(y0 - (w/2)*Math.sin(theta));
	   
	   // Point B
	   xrect[1] = (int)(xrect[0] + h*Math.sin(theta));
	   yrect[1] = (int)(yrect[0] - h*Math.cos(theta));	   
	   
	   // Point D
	   xrect[3] = (int)(x0 + (w/2)*Math.cos(theta));
	   yrect[3] = (int)(y0 + (w/2)*Math.sin(theta));
	   
	   // Point C
	   xrect[2] = (int)(xrect[3] + h*Math.sin(theta));
	   yrect[2] = (int)(yrect[3] - h*Math.cos(theta));
	   
   }
	
	public void paint(java.awt.Graphics g)
	{
		// Reset the background
		setBackground(Color.black);
		
		// Draw the polygon
		g.setColor(Color.white);
		g.drawPolygon(xrect, yrect, 4);
		g.setColor(Color.white);
		g.fillPolygon(xrect, yrect, 4);
		g.drawImage(Simulation.head,(int)(x0-48),y0,this);
		g.drawImage(Simulation.apple, (int)(xrect[1] - 19), yrect[1] - 39, this);
	}
	
	public void updateC(Position p)
	{
		getRect(p);
		java.awt.Graphics g = this.getGraphics();
		this.repaint(1);
	}
}