import java.util.*;
import java.io.*;
import java.applet.Applet;
import java.awt.*;
			   

public class Simthread extends Thread
{
	private PoleCanvas c;
	private static Random r;
	
	public Simthread(PoleCanvas pc)
	{
		c = pc;
		r = new java.util.Random();
	}
	
	public void run() 
	{
		
		simulate();
	}
	
	public void simulate()
	{
		int k = 50;  // Number of correct moves in a row required
		int uprightcount = 0;
		int move, outcome;
		int count = 0;
		boolean success = false;
		Vector tenMoves = new Vector();
		
		Network n = new Network();
		Pole p = initpole();
		
//		while (!success)
		while (true)
		{
			System.out.println("Count = " + count);
			count++;
			
			// Run neural network to get suggested move
			move = n.makeMove(p.getPos());
			System.out.println("Move = " + move);
			
			// Execute suggested move getting an 
			//outcome (fell left, right, remained upright)
			outcome = p.step(move, tenMoves);
			
			// Send outcome to the network
			n.getRes(outcome);
			
			// Update the weights based on outcome
			n.updateNet();
			
			// Draw the ten ministeps comprising the move	
			// For each step: draw it, pause a short time
			Position pres;
			for(int i = 0; i < 10; i = i+5)
			{
				pres = (Position)tenMoves.elementAt(i);
				System.out.println("i = "+i+" theta = "+pres.theta+" thetadot = "+pres.theta_dot+" x = "+pres.xbase+" xdot = "+pres.xbase_dot);
				c.updateC(pres);
				try
				{
				this.sleep(100);
				}
				catch(InterruptedException e)
				{
				}
								   
			}
	//		pres = (Position)tenMoves.elementAt(9);
	//		c.updateC(pres);
			
			if ((p.getPos().xbase > 1) || (p.getPos().xbase < -1) )
			{
				pres = p.getPos();
				pres.xbase = 0.0;
				p.setPos(pres);
			}
			
			// Update the statistics
			// Draw the statistics in a window
			
			// Pause, so simulation can be observed (if desired)
		//	Delay(1000);
			
			/* If fell*/
			if (outcome != 0)
			{
				uprightcount = 0; 
				System.out.println("************ FELL ***********");
				try		{	this.sleep(1000);	}
				catch(InterruptedException e)	{	}
				p = initpole();
			}
			else
			{
				uprightcount ++;
			}
			
			if (uprightcount > k)
				success = true;
			
		}
		
		// Write statistics to a file
	
	}
	
	public static Pole initpole()
		// Set initial position of pole:
		// Include a randomized element: pole is nearly vertical, but not quite
		// If net works okay, can try initializing with larger deviation from vertical
	{
		Position p = new Position();
		
		double ran = r.nextDouble() - 0.5;
		
		p.theta = 0.05 * ran; //Radians
		p.theta_dot = 0;
		p.xbase = 0;
		p.xbase_dot = 0;
		return new Pole(p, 1);
	}
	
}